/*
 Interpret Pascalu (semestralni prace z PJ)
 (c)2002-2003 Jindra Gottwald

 zname odlisnosti vuci borland pascalu 7:
  -string je spis jen na okrasu neumi v nem \xx ,neni jako datovy typ a nesmi byt v zavorkach
    neumi ve stringu \xx
	pr: write(a,'ahoj\n');
    nesmi byt v zavorkach
        pr: write(('ahoj'));
    neni datovy typ - nezna zadne operace
        pr: write ('a'+'b');
  -v if muze byt jen jedna podminka bez zavorek (detail, ktery lze lechce upravit)
	pr: if (a>b) then...;
  -v pascalu pokud neni splnena podminka ve for, tak nendojde k prirazeni hodnoty do promenne. zde ano
        pr: a:=5;
            for a:=10 to 5 do ...
            write(a); //pascal vypishe 5, ja hodnotu a pozmenim
  -neumi identifikator v zavorkach (detail, ktery lze lechce upravit)
	pr: (i):=3;
  -read nemuze byt bez zavorek (detail, ktery lze lechce upravit)
        pr: read;
  -read je kompatibilni s read v pascalu, ale navic lze oddelovat vstup whitspacem. nevim, jak toto ve scanf omezit
  -na vstupu readu muze byt jen int nebo real. nehlidam spatny input (znaky)
  -readln je to same jak read. neprishel jsem totiz na to, jak dostatecne verne nasimulovat pascalovsky readln (ktery neodradkuje, pokud nasleduje write(ln))
  -write realne hodnoty nelze omezit na vypis urciteho poctu cislic
        Pr: write(a:4:2);
  -zna jen 10tkovou soustavu
  -hlaseni chyb pri kompilaci je spise orientacni (ale to v borland pascalu taky :-)
*/

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

int chyba(char *st, int rad);
int CisloRadku = 1;

//begin Tabulka symbolu
enum DruhId {Nedef, Int, Real};

struct PrvekTab {
   char *ident;
   DruhId druh;
   int hodn;
   PrvekTab *dalsi;
   PrvekTab(char *i, DruhId d, int h, PrvekTab *n);
};

PrvekTab::PrvekTab(char *i, DruhId d, int h, PrvekTab *n)
{
   ident = new char[strlen(i)+1];
   strcpy(ident, i);
   druh = d; hodn=h; dalsi = n;
};

PrvekTab *TabSym,*tmpTab;

void Chyba(char *id, char *txt)
{
   printf("identifikator %s: %s\n", id, txt);
   chyba("",NULL);
}

PrvekTab *hledejId(char *id)
{
   PrvekTab *p = TabSym;
   while (p)
      if (strcmp(id,p->ident)==0)
         return p;
      else
         p = p->dalsi;
   return NULL;
}

void deklProm(char *id)
{
   static int volna_adr;
   PrvekTab *p = hledejId(id);
   if (p) {
      Chyba(id, "druha deklarace");
      return;
   }
   TabSym = new PrvekTab(id, Nedef, volna_adr, TabSym);
   volna_adr++;
}

int adrProm(char *id)
{
   PrvekTab *p = hledejId(id);
   if (!p) {
      Chyba(id, "neni deklarovan");
      return 0;
   } else
      return p->hodn;
}

DruhId idProm(char *id, int *v)
{
   PrvekTab *p = TabSym;
   while (p)
      if (strcmp(id,p->ident)==0) {
         if (v) *v = p->hodn;
         return p->druh;
      } else
         p = p->dalsi;
   return Nedef;
}

//end Tabulka symbolu

// begin Interpret

enum TypInstr {
   TA, TC, BOP, UNM, DR, ST, IFJ, JU, WRT, RD, STOP, CP, DEL, TCF
};
enum Operator {
   Plus, Minus, Times, Divide,
   Eq, NotEq, Less, Greater, LessOrEq, GreaterOrEq
};

const char* oopp[] = {
   "Plus", "Minus", "Times", "Divide",
   "Eq", "NotEq", "Less", "Greater", "LessOrEq", "GreaterOrEq"
};

typedef union cslo {
 int cele;
 float real;
} ucislo;

struct cislo {ucislo hodn; int typ;};

struct Instr {
   TypInstr typ;
   cislo   opd;
};

enum {MaxZas = 100, MaxProm = 100, MaxProg = 500, MaxStr = 10};

char* string[MaxStr];
int ps=0;
cislo z[MaxZas];          // zasobnik
int v;                  // vrchol zasobniku
cislo m[MaxProm];         // pamet promennych int
Instr p[MaxProg];       // pamet programu;
int ic;                 // citac instrukci

int Gener(TypInstr ti, int opd)
{
   if (ic+1>=MaxProg) chyba("Prilis dlouhy program",NULL);
   p[ic].typ = ti;
   p[ic].opd.hodn.cele = opd;
   p[ic].opd.typ=0;
   return ic++;
}

int GenerF(TypInstr ti, float opd)
{
   if (ic+1>=MaxProg) chyba("Prilis dlouhy program",NULL);
   p[ic].typ = ti;
   p[ic].opd.hodn.real = opd;
   p[ic].opd.typ=1;
   return ic++;
}

 void GenTR(char *id)
{
   int v;
   idProm(id, &v);
      Gener(TA, v);
      Gener(DR, 0);
}

void PutIC(int adr)
{
   p[adr].opd.hodn.cele = ic;
}

int GetIC()
{
   return ic;
}

void Print()
{
   int ic = 0;
   printf("\nVypis programu\n");
   for (;;) {
      printf("%3d: ", ic);
      switch (p[ic].typ) {
      case TA:
         printf("TA  %d\n", p[ic].opd.hodn.cele);
         break;
      case TC:
         printf("TC  %d\n", p[ic].opd.hodn.cele);
         break;
      case TCF:
         printf("TCF %f\n", p[ic].opd.hodn.real);
         break;
      case BOP:
         printf("BOP %d (%s)\n", p[ic].opd.hodn.cele, oopp[p[ic].opd.hodn.cele]);
         break;
      case UNM:
         printf("UNM\n");
         break;
      case DR:
         printf("DR\n");
         break;
      case ST:
         printf("ST\n");
         break;
      case IFJ:
         printf("IFJ %d\n", p[ic].opd.hodn.cele);
         break;
      case JU:
         printf("JU  %d\n", p[ic].opd.hodn.cele);
         break;
      case WRT:
         printf("WRT %d\n", p[ic].opd.hodn.cele);
         break;
      case RD:
         printf("RD  %d\n", p[ic].opd.hodn.cele);
         break;
      case CP:
         printf("CP\n");
         break;
      case DEL:
         printf("DEL\n");
         break;
      case STOP:
         printf("STOP\n\n");
         return;
      }
      ic++;
   }
}

void Run()
{
   Instr instr;
   ic = 0;
   v = -1;
   for (;;) {
      if (v+1 >= MaxZas) chyba("Preteceni zasobniku",NULL);
      instr = p[ic++];
      switch (instr.typ) {
      case TA:
         z[++v].hodn.cele = instr.opd.hodn.cele;
         z[v].typ = 0;
         break;
      case TC:
         z[++v].hodn.cele = instr.opd.hodn.cele;
         z[v].typ = 0;
         break;
      case TCF:
         z[++v].hodn.real = instr.opd.hodn.real;
         z[v].typ = 1;
         break;
      case BOP: {
         float left,right;
         int ltyp,rtyp;
         if (rtyp=z[v].typ) right=z[v--].hodn.real;else right=z[v--].hodn.cele;
         if (ltyp=z[v].typ) left=z[v--].hodn.real;else left=z[v--].hodn.cele;
         switch (instr.opd.hodn.cele) {
         case Plus:
            z[++v].hodn.real = left + right;
            if (!ltyp && !rtyp) {z[v].typ=0;z[v].hodn.cele=(int) floor(z[v].hodn.real);}else z[v].typ=1;
            break;
         case Minus:
            z[++v].hodn.real = left - right;
            if (!ltyp && !rtyp) {z[v].typ=0;z[v].hodn.cele=(int) floor(z[v].hodn.real);}else z[v].typ=1;
            break;
         case Times:
            z[++v].hodn.real = left * right;
            if (!ltyp && !rtyp) {z[v].typ=0;z[v].hodn.cele=(int) floor(z[v].hodn.real);}else z[v].typ=1;
            break;
         case Divide:
            if (right==0) chyba("deleni nulou",NULL);
            z[++v].hodn.real = left / right;
            z[v].typ=1;
            break;
         case Eq:
            z[++v].hodn.cele = left == right;
            z[v].typ=0;
            break;
         case NotEq:
            z[++v].hodn.cele = left != right;
            z[v].typ=0;
            break;
         case Less:
            z[++v].hodn.cele = left < right;
            z[v].typ=0;
            break;
         case Greater:
            z[++v].hodn.cele = left > right;
            z[v].typ=0;
            break;
         case LessOrEq:
            z[++v].hodn.cele = left <= right;
            z[v].typ=0;
            break;
         case GreaterOrEq:
            z[++v].hodn.cele = left >= right;
            z[v].typ=0;
            break;
         }
         break;
         }
      case UNM:
         if (z[v].typ) z[v].hodn.real=-z[v].hodn.real;else z[v].hodn.cele=-z[v].hodn.cele;
         break;
      case CP:
         z[v+1] = z[v];
         v++;
         break;
      case DEL:
         v--;
         break;
      case DR:
         if (z[v].hodn.cele>=MaxProm) chyba("Prilis mnoho promenych",NULL);
         if (m[z[v].hodn.cele].typ) {z[v].hodn.real = m[z[v].hodn.cele].hodn.real;z[v].typ=1;}
          else {z[v].hodn.cele = m[z[v].hodn.cele].hodn.cele;z[v].typ=0;}
         break;
      case ST: {
         cislo c=z[v--];
         float val;
         if (c.typ) val=c.hodn.real; else val=c.hodn.cele;
         int adr = z[v--].hodn.cele;
         if (adr>=MaxProm) chyba("Prilis mnoho promenych",NULL);
         if (m[adr].typ) if (c.typ) m[adr].hodn.real = c.hodn.real;else m[adr].hodn.real = c.hodn.cele;
         else if (c.typ) chyba("Nekompatibita typu",NULL);
         else m[adr].hodn.cele=val;
         break;
         }
      case IFJ:
         if (!z[v--].hodn.cele) ic = instr.opd.hodn.cele;
         break;
      case JU:
         ic = instr.opd.hodn.cele;
         break;
      case WRT:
         if (instr.opd.hodn.cele==0) printf("\n");
         else if (instr.opd.hodn.cele==1) if (z[v].typ) printf("%f", z[v--].hodn.real); else printf("%d", z[v--].hodn.cele);
         else if (instr.opd.hodn.cele==2) printf("%s",string[z[v--].hodn.cele]);
         break;
      case RD:
         if (instr.opd.hodn.cele==0) scanf("%d",&m[z[v--].hodn.cele].hodn.cele);
         else if (instr.opd.hodn.cele==1) scanf("%f",&m[z[v--].hodn.cele].hodn.real);
         break;
      case STOP:
         return;
      }
   }
}
// end Interpret

//begin Lexikalni analyzator
#define LEX_NULL 0
#define	LEX_ERR 1
#define	LEX_IDENT 2
#define	LEX_INT 3
#define	LEX_FLOAT 4
#define LEX_STR 5
#define LEX_KW_SP 6

int LexAInt = 0;
double LexAFloat = 0;
char LexAIdent[2048];
char LexAStr[255];
char LexASpec[2];
typedef enum {Kvar,Kif,Kthen,Kelse,Kfor,Kto,Kdownto,Kdo,Kbegin,Kend,Kwrite,Kread,Kwriteln,Kreadln,Kinteger,Kreal,IDENT,
	      Sequal,Sleft,Sright,Sassign,Splus,Sminus,Sless,Sgreat,Snon,Slessoreq,Sgreatoreq,Sstrednik,Scarka,Sdot,S2dot,Smal,Sdiv,UNKNOW,
	      NONE
	      } LexTab;
LexTab LexATab=NONE;

int Token;
FILE *fp;

const struct {char *slovo; LexTab symb;} Tab[]= {
  {"if", Kif},
  {"then",Kthen},
  {"else",Kelse},
  {"for",Kfor},
  {"to",Kto},
  {"downto",Kdownto},
  {"do",Kdo},
  {"var",Kvar},
  {"begin",Kbegin},
  {"end",Kend},
  {"read",Kread},
  {"write",Kwrite},
  {"readln",Kreadln},
  {"writeln",Kwriteln},
  {"real",Kreal},
  {"integer",Kinteger},
  {"=", Sequal},
  {":=", Sassign},
  {":", S2dot},
  {"(", Sleft},
  {")", Sright},
  {"+", Splus},
  {"-", Sminus},
  {"<", Sless},
  {">", Sgreat},
  {"<=", Slessoreq},
  {">=", Sgreatoreq},
  {"<>", Snon},
  {",", Scarka},
  {";", Sstrednik},
  {".", Sdot},
  {"*", Smal},
  {"/", Sdiv},
  {NULL, IDENT}
};

LexTab IsKeyWord(char *id) {
 int i=0;
 while (Tab[i].slovo)
   if (!(strcmp(strlwr(id),Tab[i].slovo))) return Tab[i].symb;
   else i++;
 return IDENT;
}

LexTab IsSpec(char *id) {
 int i=0;
 while (Tab[i].slovo)
   if (!(strcmp(strlwr(id),Tab[i].slovo))) return Tab[i].symb;
   else i++;
 return UNKNOW;
}

void DoneLexAn (void) {
   fclose(fp);
}

int chyba(char *st, int rad) {
   if (rad!=NULL) printf("%s (radek %d)\n",st,rad);
   else printf("%s\n",st);
   DoneLexAn();
   exit(1);
   return(1);
}

int InitLexAn(char *fname) {
  int re=0;
  if ((fp=fopen(fname,"rt")) == NULL) re=1;
  return re;

}

void ChrPis (char *str , char c) {
   strncat(str,&c,1);
}

void StrSmaz (char *str) {
   memset(str,'\0',strlen(str));
}

int NextToken(void) {
   int stav=0,i;
   char c;
   int exp,expsign,dms;
   LexATab=NONE;
   while (!feof(fp)) {
      c=fgetc(fp);
      switch (stav) {
	case 0:if (c=='\t' || c==' ') break;
	       if (c=='\n') {CisloRadku++;break;}
	       if (isalpha(c) || c=='_') {stav=1;StrSmaz(LexAIdent);ChrPis(LexAIdent,c);break;}
	       if (isdigit(c)) {stav=3;dms=0;LexAInt=c-'0';break;}
	       if (c=='+' || c=='-' || c==')' || c=='=' || c==';' || c=='.' || c==',' || c=='*' || c=='/') {stav=9;StrSmaz(LexASpec);ChrPis(LexASpec,c);break;}
	       if (c=='(') {stav=15;StrSmaz(LexASpec);ChrPis(LexASpec,c);break;}
	       if (c=='<') {stav=18;StrSmaz(LexASpec);ChrPis(LexASpec,c);break;}
	       if (c=='>') {stav=19;StrSmaz(LexASpec);ChrPis(LexASpec,c);break;}
	       if (c==':') {stav=10;StrSmaz(LexASpec);ChrPis(LexASpec,c);break;}
	       if (c=='{') {stav=12;break;}
	       if (c=='\'') {StrSmaz(LexAStr);stav=2;break;}
	       if (c==EOF) return (LEX_NULL);
	       return(LEX_ERR);
	case 1:if (isalpha(c) || c=='_' || isdigit(c)) {ChrPis(LexAIdent,c);break;}
	       LexATab=IsKeyWord(LexAIdent);
	       ungetc(c,fp);
	       if (LexATab!=IDENT) return(LEX_KW_SP);
	       else return(LEX_IDENT);
	case 2:if (c=='\'') {return(LEX_STR);}
	       if (c!=EOF && c!='\n') {ChrPis(LexAStr,c);break;}
	       ungetc(c,fp);
	       return(LEX_ERR);
	case 3:if (isdigit(c)) {LexAInt=LexAInt*10+(c-'0');break;}
	       if (c=='.') {stav=4;LexAFloat=LexAInt;dms=1;break;}
	       if (c=='e' || c=='E') {LexAFloat=LexAInt;stav=6;break;}
	       ungetc(c,fp);
	       return(LEX_INT);
	case 4:if (isdigit(c))
	       {stav=5;LexAFloat+=(c-'0')*pow(0.1,dms++);break;}
	       ungetc(c,fp);
	       return(LEX_ERR);
	case 5:if (isdigit(c)) {stav=5;LexAFloat=LexAFloat+(c-'0')*dms++;break;}
	       if (c=='e' || c=='E') {stav=6;break;}
	       ungetc(c,fp);
	       return(LEX_FLOAT);
	case 6:exp=0;expsign=1;
	       if (c=='+') {expsign=1;stav=7;break;}
               if (c=='-') {expsign=0;stav=7;break;}
	       if (isdigit(c)) {exp=exp*10+(c-'0');stav=8;break;}
	       ungetc(c,fp);
	       return(LEX_ERR);
	case 7:if (isdigit(c)) {exp=exp*10+(c-'0');stav=8;break;}
	       ungetc(c,fp);
	       return(LEX_ERR);
	case 8:if (isdigit(c)) {exp=exp*10+(c-'0');break;}
	       if (expsign) {LexAFloat*=pow10(exp);}
	       else {LexAFloat*=pow(0.1,exp);}
	       ungetc(c,fp);
	       return(LEX_FLOAT);
	case 9:ungetc(c,fp);
	       LexATab=IsSpec(LexASpec);
	       return(LEX_KW_SP);
	case 10:
	       if (c=='=') {stav=9;ChrPis(LexASpec,c);break;}
	       ungetc(c,fp);
	       LexATab=IsSpec(LexASpec);
	       return(LEX_KW_SP);
	case 11:
	       ungetc(c,fp);
	       LexATab=IsSpec(LexASpec);
	       return(LEX_KW_SP);
	case 12:
	       if (c=='}') {stav=0;break;}
	       if (c==EOF) {return(LEX_ERR);}
	       break;
	case 15:
	       if (c=='*') {stav=16;break;}
	       ungetc(c,fp);
	       LexATab=IsSpec(LexASpec);
	       return(LEX_KW_SP);
	case 16:
	       if (c=='*') {stav=17;break;}
	       if (c==EOF) {return(LEX_ERR);}
	       break;
	case 17:
	       if (c==')') {stav=0;break;}
	       if (c=='*') {break;}
	       if (c==EOF) {return(LEX_ERR);}
	       stav=16;break;
	case 18:
	       if (c=='=' || c=='>') {stav=9;*(LexASpec+strlen(LexASpec))=c;break;}
	       ungetc(c,fp);
	       LexATab=IsSpec(LexASpec);
	       return(LEX_KW_SP);
	case 19:
	       if (c=='=') {stav=9;*(LexASpec+strlen(LexASpec))=c;break;}
	       ungetc(c,fp);
	       LexATab=IsSpec(LexASpec);
	       return(LEX_KW_SP);
	default:
	       return(LEX_ERR);
      }
   }
   return (0);
}
//end Lexikalni analyzator

//begin Syntakticky analyzator
void Program (void);
void Xprogram (void);
void Slozenyprikaz (void);
void Vdeklarace (void);
void Deklarace (void);
void Xdeklarace (void);
void Xidentifikator (void);
void Intorreal (PrvekTab *tmp);
void Prikaz (void);
void Xprikaz (void);
void Vyraz (void);
void Podminka (void);
void Castelse(int adrIFJ);
int Toordown (void);
void Identorvyr (void);
void Vyrorstr (void);
void Xvyrorstr (void);
Operator ROperator (void);
void Term (void);
void Zbvyrazu (void);
void Faktor (void);
void Zbtermu (void);
void XR(void);

void Vyraz (void) {
 if (LexATab==Splus) {
  Token=NextToken();
  Term();Zbvyrazu();
 } else
 if (LexATab==Sminus) {
  Token=NextToken();
  Term();
  Gener(UNM,0);
  Zbvyrazu();
 } else {Term();Zbvyrazu();}
}

void Zbvyrazu(void) {
 if (LexATab==Splus) {
  Token=NextToken();
  Term();
  Gener(BOP,Plus);
  Zbvyrazu();
 } else
 if (LexATab==Sminus) {
  Token=NextToken();
  Term();
  Gener(BOP,Minus);
  Zbvyrazu();
 }
}

void Term(void) {
 Faktor();
 Zbtermu();
}

void Zbtermu(void) {
 if (LexATab==Smal) {
  Token=NextToken();
  Faktor();
  Gener(BOP,Times);
  Zbtermu();
 } else
 if (LexATab==Sdiv) {
  Token=NextToken();
  Faktor();
  Gener(BOP,Divide);
  Zbtermu();
 }
}

void Faktor(void) {
 if (Token==LEX_IDENT) {GenTR(LexAIdent);Token=NextToken();}
 else if (Token==LEX_INT) {Gener(TC,LexAInt);Token=NextToken();}
 else if (Token==LEX_FLOAT) {GenerF(TCF,LexAFloat);Token=NextToken();}
 else if (LexATab==Sleft) {Token=NextToken();
  Vyraz();
  if (LexATab!=Sright) {chyba ("ocekavam )",CisloRadku);} else Token=NextToken();
 }
 else chyba("chyba v syntaxy",CisloRadku);
}

void Xvyrorstr (void) {
 if (LexATab==Scarka) {Token=NextToken();
  Vyrorstr();Xvyrorstr();
 }
}

void Vyrorstr (void) {
 if (Token==LEX_STR) {
 if (ps+1>=MaxStr) chyba("Prilis mnoho stringu",NULL);
 string[ps] = new char[strlen(LexAStr)+1];
 strcpy(string[ps],LexAStr);
 Gener(TA,ps++);Gener(WRT,2);Token=NextToken();}
 else {Vyraz();Gener(WRT,1);}
}

void Podminka (void) {
  Vyraz();
  Operator op=ROperator();
  Vyraz();
  Gener(BOP, op);
}

Operator ROperator (void) {
 switch (LexATab) {
  case Sequal: Token=NextToken();return(Eq);
  case Sless: Token=NextToken();return(Less);
  case Sgreat: Token=NextToken();return(Greater);
  case Slessoreq: Token=NextToken();return(LessOrEq);
  case Sgreatoreq: Token=NextToken();return(GreaterOrEq);
  case Snon: Token=NextToken();return(NotEq);
  default: chyba ("ocekavam operator",CisloRadku);
  return(Plus);
 }
}

void Xprikaz (void) {
 if (LexATab==Sstrednik) {Token=NextToken();
  Prikaz();
  Xprikaz();
 }
}

void Castelse(int adrIFJ) {
 if (LexATab==Kelse) {
  Token=NextToken();
  int adrJU=Gener(JU,0);
  PutIC(adrIFJ);
  Prikaz();
  PutIC(adrJU);
 }
 else PutIC(adrIFJ);
}

int Toordown(void) {
 switch (LexATab) {
  case Kto: Token=NextToken();return(1);
  case Kdownto: Token=NextToken();return(2);
  default: chyba("ocekavam to nebo downto",CisloRadku);
 }
 return(0);
}

void XR(void) {
    if (LexATab==Scarka) {Token=NextToken();
     if (Token==LEX_IDENT) {
      Gener(TA,adrProm(LexAIdent));
      if (idProm(LexAIdent,NULL)==Int) Gener(RD,0); else Gener(RD,1);
      Token=NextToken();
      XR();
     } else chyba("ocekavam indetifikator",CisloRadku);
    }
}

void Prikaz (void) {
 int adrIFJ,adrJU,ident,tmp,l,h;
 Instr in;
 switch (LexATab) {
  case IDENT:
    Gener(TA, adrProm(LexAIdent));
    Token=NextToken();
    if (LexATab==Sassign) {
     Token=NextToken();Vyraz();Gener(ST,0);}
    else chyba ("ocekavam :=",CisloRadku);
    break;
  case Kbegin:
    Slozenyprikaz();break;
  case Kread:
  case Kreadln:
    Token=NextToken();
    if (LexATab==Sleft) {Token=NextToken();
     if (Token==LEX_IDENT) {
      Gener(TA,adrProm(LexAIdent));
      if (idProm(LexAIdent,NULL)==Int) Gener(RD,0); else Gener(RD,1);
      Token=NextToken();
      XR();
      if (LexATab==Sright) {Token=NextToken();break;}
      else chyba("ocekavam )",CisloRadku);
     }
     else chyba("ocekavam indetifikator",CisloRadku);
    }
    else chyba("ocekavam (",CisloRadku);
  case Kwrite:
    Token=NextToken();
    if (LexATab==Sleft) {Token=NextToken();
     Vyrorstr();
     Xvyrorstr();
     if (LexATab==Sright) {Token=NextToken();break;}
     else chyba("ocekavam )",CisloRadku);
    }
//    else chyba("ocekavam (",CisloRadku);
     break;
  case Kwriteln:
    Token=NextToken();
    if (LexATab==Sleft) {Token=NextToken();
     Vyrorstr();
     Xvyrorstr();
     Gener(WRT,0);
     if (LexATab==Sright) {Token=NextToken();break;}
     else chyba("ocekavam )",CisloRadku);
    }
//    else chyba("ocekavam (",CisloRadku);
    else Gener(WRT,0);break;
  case Kif:
    Token=NextToken();
    Podminka();
    adrIFJ=Gener(IFJ,0);
    if (LexATab!=Kthen) chyba("ocekavam then",CisloRadku);
    Token=NextToken();
    Prikaz();Castelse(adrIFJ);break;
  case Kfor:
    Token=NextToken();
    if (Token!=LEX_IDENT) chyba("ocekavam identifikator",CisloRadku);
    if (idProm(LexAIdent,NULL)!=Int) chyba("ocekavam promennou typu integer",CisloRadku);
    ident=adrProm(LexAIdent);
    Token=NextToken();
    if (LexATab!=Sassign) chyba("ocekavam :=",CisloRadku);
    Token=NextToken();
    Gener(TA,ident);
    Vyraz();
    Gener(ST,0);
    tmp=Toordown();
    Vyraz();
//test!
    if (LexATab!=Kdo) chyba("ocekavam do",CisloRadku);
    Token=NextToken();
    if (tmp==1) {
     adrJU=GetIC();
     Gener(CP,0);Gener(TA,ident);Gener(DR,0);Gener(BOP,GreaterOrEq);adrIFJ=Gener(IFJ,0);
     Prikaz();
     Gener(TA,ident);Gener(TA,ident);Gener(DR,0);Gener(TC,1);Gener(BOP,Plus);Gener(ST,0);//inc(ident)
     Gener(JU,adrJU);
     PutIC(adrIFJ);
     Gener(TA,ident);Gener(TA,ident);Gener(DR,0);Gener(TC,1);Gener(BOP,Minus);Gener(ST,0);//dec(ident)
     Gener(DEL,0);
    }
    else if (tmp==2) {
     adrJU=GetIC();
     Gener(CP,0);Gener(TA,ident);Gener(DR,0);Gener(BOP,LessOrEq);adrIFJ=Gener(IFJ,0);
     Prikaz();
     Gener(TA,ident);Gener(TA,ident);Gener(DR,0);Gener(TC,1);Gener(BOP,Minus);Gener(ST,0);//dec(ident)
     Gener(JU,adrJU);
     PutIC(adrIFJ);
     Gener(TA,ident);Gener(TA,ident);Gener(DR,0);Gener(TC,1);Gener(BOP,Plus);Gener(ST,0);//inc(ident)
     Gener(DEL,0);
    }
    break;
  default: break;
 }
}

void Xidentifikator(void) {
 if (LexATab==Scarka) {Token=NextToken();
  if (Token==LEX_IDENT) {deklProm(LexAIdent);Token=NextToken();
   Xidentifikator();
  }
  else chyba("ocekavam identifikator",CisloRadku);
 }
}

void RetypeAll(PrvekTab *tmp, DruhId id){
   PrvekTab *p = TabSym;
   while (p && p!=tmp->dalsi) {
        p->druh=id;
        if (id==Int) m[p->hodn].typ=0; else m[p->hodn].typ=1;
//        if (id==Int) p->hodn.cele=floor(p->hodn.realne);
        p = p->dalsi;
   }
}

void Intorreal (PrvekTab *tmp) {
 if (LexATab==Kinteger) {Token=NextToken();RetypeAll(tmp,Int);} else
  if (LexATab==Kreal) {Token=NextToken();RetypeAll(tmp,Real);}
   else {chyba("ocekavam integer nebo real",CisloRadku);}
}

void Deklarace (void) {
 if (Token==LEX_IDENT) {
  deklProm(LexAIdent);
  tmpTab=TabSym;
  Token=NextToken();
  Xidentifikator();
  if (LexATab==S2dot) {Token=NextToken();Intorreal(tmpTab);}
  else chyba("ocekavam :",CisloRadku);
 }
 else chyba("ocekavam identifikator",CisloRadku);
}

void Xdeklarace (void) {
 if (Token==LEX_IDENT) {
  Deklarace();
 }
 if (LexATab==Sstrednik) {Token=NextToken();
   Xdeklarace();
 }
}

void Vdeklarace (void) {
 if (LexATab==Kvar) {
  Token=NextToken();
  Deklarace();
  if(LexATab==Sstrednik) Token=NextToken();
  else chyba("ocekavam ;",CisloRadku);
  Xdeklarace();
 }
}

void Xprogram (void) {
 if (LexATab==Kvar) {
  Vdeklarace();
  Xprogram();
 }
}

void Slozenyprikaz (void) {
 if (LexATab==Kbegin) Token=NextToken();
 else chyba("ocekavam begin",CisloRadku);
 Prikaz();
 Xprikaz();
 if (LexATab==Kend) Token=NextToken();
 else chyba("ocekavam end",CisloRadku);
}

void Program (void) {
 Xprogram();
 Slozenyprikaz();
 if (LexATab==Sdot) { Token=NextToken();Gener(STOP,0);
  if (Token!=LEX_NULL) chyba("extra znaky na konci",CisloRadku);}
 else chyba("ocekavam .",CisloRadku);
}

// end Syntakticky analyzator

int main (int argc, char *argv[]) {
   if (argc==1) {if (InitLexAn("test.pas")) chyba("Zadej jako parametr nazev souboru. (implicitne test.pas)",NULL);}
   else {
     if (InitLexAn(argv[1])) {
      char* jmeno;
      strcpy(jmeno,argv[1]);strncat(jmeno,".pas",4);
//      printf("\n%s\n",jmeno);
      if (InitLexAn(jmeno)) chyba("Chyba pri otevirani souboru",NULL);
     }
   }

   Token=NextToken();

   if (Token!=LEX_NULL) Program();
   else chyba ("prazdny soubor",NULL);

//   Print();
   Run();

   DoneLexAn();
//   scanf("%s");
   return(0);
}